/*
Scrivere un programma per la gestione delle prenotazioni degli esami universitari. Ogni  prenotazione  caratterizzata dalle seguenti informazioni: nominativo, matricola, codice materia, giorno dell'esame.
Le prenotazioni  sono organizzate in memoria come una vettore di 50 prenotazioni.
Si assuma che per uno studente non possa esserci pi di una prenotazione per una data materia.
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1) Inserimento di una nuova prenotazione;
2)Visualizzazione delle prenotazioni relative a una certa materia e a una certo giorno (chiedere materia e giorno);
3) Ricerca di una prenotazione (chiedere la matricola e la materia);
4) Salvataggio su file delle prenotazioni relative a una certa materia.

All'avvio del programma i valori precedentemente salvate su file devono essere letti e copiati nel vettore mediante una funzione di inizializzazione del vettore. 

*/

#include <stdio.h>
#include <string.h>

struct pren {
       char nominativo[30];
       long matricola;
       int codice;
       char giorno[15];
       };
       
void inserimento(struct pren *V, int *pn)
{
     struct pren p;
     
     if(*pn<50)
        {
            printf("Nominativo: ");
            scanf("%s",p.nominativo);
            printf("Matricola: ");
            scanf("%ld",&p.matricola);
            printf("Codice materia : ");
            scanf("%d",&p.codice);
            printf("Giorno dell'esame gg/mm/aaaa: ");
            scanf("%s",p.giorno);
            V[*pn]=p;
            (*pn)++;
        }
     else printf("Vettore pieno\n");
}

void visualizza(struct pren *V, int n)
{
     int i;
     int materia;
     char giorno[15];
     
     printf("Codice materia: ");
     scanf("%d",&materia);
     printf("Giorno dell'esame: ");
     scanf("%s",giorno);
     
     for(i=0;i<n;i++)
        if(V[i].codice==materia && strcmp(V[i].giorno,giorno)==0)
           {
                printf("Nominativo: %s\n",V[i].nominativo);
                printf("Matricola: %ld\n",V[i].matricola);
           }
}

void ricerca(struct pren *V, int n)
{
     long matricola;
     int materia;
     int i;
     
     printf("Matricola: ");
     scanf("%ld",&matricola);
     printf("Codice materia: ");
     scanf("%d",&materia);
     
     for(i=0;i<n;i++)
         if(V[i].matricola==matricola && V[i].codice==materia)
            break;
     
     if(i<n)  /*trovato*/
            {
               printf("Nominativo: %s\n",V[i].nominativo);
               printf("Giorno prenotazione: %s\n",V[i].giorno);
            }
     else printf("Prenotazione non trovata\n");
}

void salva(struct pren *V, int n)
{
     int i;
     FILE *pf;
     int materia;
     
     printf("Codice materia: ");
     scanf("%d",&materia);
     
     pf=fopen("prenotazioni.pre","wb");
     if(pf!=NULL)
        {
             for(i=0;i<n;i++)
                if(V[i].codice==materia)
                   fwrite(&V[i],sizeof(struct pren),1,pf);
             fclose(pf);
        }
     else printf("Errore in scrittura\n");
}

void inizializza(struct pren *V, int *pn)
{
     struct pren p;
     int i;
     FILE *pf;
     
     i=0;
     pf=fopen("prenotazioni.pre","rb");
     if(pf!=NULL)
         {
              while(i<50 && fread(&p,sizeof(struct pren),1,pf)>0)
                 {
                     V[i]=p;
                     i++;
                 }
              fclose(pf);
         }
     else printf("Errore in lettura\n");
     
     *pn=i;
}


main() {
       struct pren A[50];
       int n;
       int scelta;
       
       inizializza(A,&n);
       do{
             printf("Scegli tra:\n");
             printf("1)Inserisci\n2)Visualizza\n");
             printf("3)Ricerca\n4)Salva su file\n");
             printf("0)Fine esecuzione\n");
             scanf("%d",&scelta);
             switch(scelta){
                    case 1: inserimento(A,&n);
                            break;
                    case 2: visualizza(A,n);
                            break;
                    case 3: ricerca(A,n);
                            break;
                    case 4: salva(A,n);
                            break;
                    default: ;
                    }
             }while(scelta!=0);
}
              
               
                                      
