/*
Scrivere un programma per la gestione delle prenotazioni degli esami ECDL. Ogni  prenotazione  caratterizzata dalle seguenti informazioni: nominativo, numero scheda ECDL, codice modulo ECDL, giorno dell'esame.
Le prenotazioni  sono organizzate in memoria come una vettore di 40 prenotazioni.
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1) Inserimento di una nuova prenotazione;
2)Visualizzazione delle prenotazioni relative a una certo modulo ECDL e a una certo giorno (chiedere modulo e giorno);
3) Ricerca di una prenotazione (chiedere il numero di scheda e il codice modulo);
4) Salvataggio su file delle prenotazioni;
5) Lettura da file e copia nel vettore delle prenotazioni relative a un certo giorno;


*/

#include <stdio.h> 
#include <string.h>

struct prenota {
       char nominativo[20];
       int scheda;
       int modulo;
       char giorno[12];
       };
       
void inserimento(struct prenota V[40],int *pn)
{
     struct prenota e;
     if(*pn<40)
     {
               printf("Nominativo: ");
               scanf("%s",e.nominativo);
               printf("Scheda: ");
               scanf("%d",&e.scheda);
               printf("Codice modulo: ");
               scanf("%d",&e.modulo);
               printf("Giorno: ");
               scanf("%s",e.giorno);
               V[*pn]=e;
               (*pn)++; 
     }
     else printf("Vettore pieno\n");
}

void visualizzazione(struct prenota V[40],int n)
{
     int i,modulo;
     char giorno[12];
     
     printf("Codice modulo: ");
     scanf("%d",&modulo);
     printf("Giorno: ");
     scanf("%s",giorno);
     
     for(i=0;i<n;i++)
        if(V[i].modulo==modulo && strcmp(V[i].giorno,giorno)==0)
            {
              printf("Nominativo: %s\n",V[i].nominativo);
              printf("Scheda: %d\n",V[i].scheda);
            
            }
}

void ricerca(struct prenota V[40],int n)
{
     int i,scheda,modulo;
     
     
     printf("Scheda: ");
     scanf("%d",&scheda);
     printf("Codice modulo: ");
     scanf("%d",&modulo);
     
     for(i=0;i<n;i++)
          if(V[i].scheda==scheda && V[i].modulo==modulo)
              break;
              
     if(i<n)
     {
            printf("Nominativo: %s\n",V[i].nominativo);
            printf("Giorno: %s\n",V[i].giorno);
     }
    else printf("Elemento non trovato\n");
}

void salvataggio(struct prenota V[40],int n)
{
     FILE *pf;
     int i;
     pf=fopen("ecdl.dat","wb");
     if(pf!=NULL)
     {
        for(i=0;i<n;i++)
          fwrite(&V[i],sizeof(struct prenota),1,pf);
        fclose(pf);
     }
     else printf("ERRORE\n");
}


void lettura(struct prenota V[40],int *pn)
{
     FILE *pf;
     int i=0;
     struct prenota e;
     char giorno[12];
     
    
     
     pf=fopen("ecdl.dat","rb");
     if(pf!=NULL)
     {
         printf("Giorno: ");
         scanf("%s",giorno);
                
         while(i<40 && fread(&e,sizeof(struct prenota),1,pf)>0)
            if(strcmp(e.giorno,giorno)==0)     
               {
                 V[i]=e;
                 i++;
               }
        fclose(pf);
     }
     else printf("ERRORE\n");
     
     *pn=i;
}

main() {
       struct prenota A[40];
       int n=0;
       int scelta;
       do {
           printf("Scegli tra: \n");
           printf("1) Inserimento\n2) Visualizzazione\n");
           printf("3) Ricerca\n4) Salvataggio\n");
           printf("5) Lettura\n0) Fine\n");
           scanf("%d",&scelta);
           switch(scelta) {
                          case 1: inserimento(A,&n);
                                  break;
                          case 2: visualizzazione(A,n);
                                  break;
                          case 3: ricerca(A,n);
                                  break;
                          case 4: salvataggio(A,n);
                                  break;
                          case 5: lettura(A,&n);
                                  break;
                          default:;
                          }
       }while(scelta!=0);

}
                          
     
               
