/*
Scrivere un programma per la gestione degli esami EUCIP. Ogni  esame  caratterizzato dalle seguenti informazioni: cognome e nome studente, numero skill card EUCIP, codice modulo, voto (0.30) , data esame.
Gli esami sono organizzati in memoria come un vettore di 30 elementi
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1) Inserimento di un nuovo esame;
2)Visualizzazione degli esami relativi a un certo modulo;
3) Ordinamento degli elementi rispetto al numero di skill card;
4) Salvataggio su file degli esami con voto maggiore o uguale a 18.
5) Lettura da file dei valori salvati su file e visualizzazione sullo schermo.


*/

#include <stdio.h>

struct esame {
       char cognome [30];
       char nome [30];
       long numero;
       int modulo;
       int voto;
       char data[12];
       };

void inserimento (struct esame *V, int *pn)
{
     struct esame e;
     if (*pn<30)
     {
                printf ("Cognome : ");
                scanf (" %s", e.cognome);
                printf ("Nome: ");
                scanf ("%s", e.nome);
                printf ("Numero skill card: ");
                scanf ("%ld", &e.numero);
                printf ("Codice modulo: ");
                scanf ("%d", &e.modulo);
                printf ("Voto (0...30): ");
                scanf ("%d", &e.voto);
                printf ("Data esame: ");
                scanf ("%s", e.data);
                V[*pn]=e;
                (*pn)++;
         }
     else printf ("Vettore pieno\n");
}

void visualizzazione (struct esame *V, int n)
{
     int i;
     int modulo;
     
     printf ("Codice Modulo: ");
     scanf ("%d", &modulo);
     
     for (i=0; i<n; i++)
       if (V[i].modulo==modulo)
         {
            printf ("Cognome: %s \n", V[i].cognome);
            printf ("Nome: %s  \n", V[i].nome);
            printf ("Numero skill card: %ld  \n", V[i].numero);
            printf ("Voto : %d  \n", V[i].voto);
            printf ("Data esame: %s  \n", V[i].data);
         }
}
 
void ordinamento (struct esame*V, int n)
{
     int sup, i;
     struct esame temp ;
     
     for (sup=n-1; sup>0; sup--)
      for (i=0; i<sup; i++)
       if ( V[i].numero > V[i+1].numero)
        {
          temp= V[i];
          V[i]=V[i+1];
          V[i+1]=temp;
        }
}

void salvataggio (struct esame *V, int n)
{
     FILE *pf;
     int i;
     pf=fopen("eucip.dat", "wb");
     if (pf)
     {
            for (i=0; i<n; i++)
              if (V[i].voto >= 18)
                  fwrite (&V[i], sizeof( struct esame), 1 , pf);
            fclose (pf);
     }
     else printf ("ERRORE IN SCRITTURA\n");
}

void lettura (   )
{
     FILE *pf;
     struct esame e;
     int i=0;
     
     pf=fopen ("eucip.dat", "rb");
     if (pf)
     { 
            while (fread (&e, sizeof (struct esame), 1, pf)>0) 
            {
                  printf ("Cognome: %s  \n", e.cognome);
                  printf ("Nome: %s  \n", e.nome);
                  printf ("Numero skill card: %ld  \n", e.numero);
                  printf ("Voto : %d  \n", e.voto);
                  printf ("Data esame: %s  \n", e.data);
            }
       fclose (pf);
     }
     else printf ("ERRORE IN LETTURA");
}
     
     
     
main ( )  {
     struct esame A[30];
     int n=0;
     int scelta;
     do {
         printf (" \n Scegli tra: \n");
         printf ("  1) Inserimento\n  2) Visualizzazione\n ");
         printf (" 3) Ordinamento\n  4) Salvataggio\n  5) Lettura\n ");
         printf (" 0) Fine esecuzione\n ");
         scanf ("%d", &scelta);
         switch (scelta)  {
                case 1: inserimento (A, &n);
                break;
                case 2: visualizzazione (A, n);
                break;
                case 3: ordinamento (A, n);
                break;
                case 4: salvataggio (A, n);
                break;
                case 5: lettura ();
                break;
                default: ;
                }
         } while (scelta !=0);
}

